var audio = {
    plugin : null,
    timeout : null
}

audio.init = function(){
	var success = true;

	this.plugin = document.getElementById("pluginAudio");

	if (!this.plugin){
		success = false;
	}else{
		$("#audio_controls .volume").html(audio.getVolume());
	}

	return success;
}

audio.getOutputDevice = function(){
	return this.plugin.GetOutputDevice();
}

audio.getVolume = function(){
	return this.plugin.GetVolume();
}

audio.isMuted = function(){
	if(this.plugin.GetUserMute() == PLR_TRUE){
		return true;
	}
	return false; 
}

audio.switchMute = function(){
	//PL_AUDIO_OUTPUT_DEVICE_EXTERNAL = 3, PL_TV_PRODUCT_TYPE_BD = 2
	if (audio.getOutputDevice() == PL_AUDIO_OUTPUT_DEVICE_EXTERNAL || tv.getProductType() == PL_TV_PRODUCT_TYPE_BD){
		return;
	}else{
		// Toggle mute status
		if(this.isMuted()){
			this.plugin.SetUserMute(PLR_FALSE);
		}else{
			this.plugin.SetUserMute(PLR_TRUE);
		}
		//PL_AUDIO_OUTPUT_DEVICE_RECEIVER = 4
		if( audio.getOutputDevice() == PL_AUDIO_OUTPUT_DEVICE_RECEIVER){
			return;
		}else{
			this.showInfo(1);
		}
	}
}

audio.volumeUp = function (){
	//PL_AUDIO_OUTPUT_DEVICE_EXTERNAL= 3, PL_TV_PRODUCT_TYPE_BD = 2
	if (audio.getOutputDevice() == PL_AUDIO_OUTPUT_DEVICE_EXTERNAL || tv.getProductType() == PL_TV_PRODUCT_TYPE_BD){
		return;
	}else{
		if(this.isMuted()){
			audio.switchMute();
		}
		//PL_AUDIO_VOLUME_KEY_UP = 0
		this.plugin.SetVolumeWithKey(0);
		//PL_AUDIO_OUTPUT_DEVICE_RECEIVER= 4
		if( audio.getOutputDevice() == PL_AUDIO_OUTPUT_DEVICE_RECEIVER ){ 
			return;
		}else{
			this.showInfo(2);
		}
	}
}

audio.volumeDown = function (){
	//PL_AUDIO_OUTPUT_DEVICE_EXTERNAL = 3, PL_TV_PRODUCT_TYPE_BD = 2
	if ( audio.getOutputDevice() == PL_AUDIO_OUTPUT_DEVICE_EXTERNAL || tv.getProductType() == PL_TV_PRODUCT_TYPE_BD){
		return;
	}else{
		if(this.isMuted()){
			audio.switchMute();
		}
		//PL_AUDIO_VOLUME_KEY_UP = 1
		this.plugin.SetVolumeWithKey(1);
		//PL_AUDIO_OUTPUT_DEVICE_RECEIVER = 4
		if( audio.getOutputDevice() == PL_AUDIO_OUTPUT_DEVICE_RECEIVER){ 
			return;
		}else{
			this.showInfo(3);
		}
	}
}


audio.showInfo = function(type){
	//alert("show audio info "+type);
	$("#audio_controls .mute, #audio_controls .volume").hide();
	switch (type) {
		case 1:
			clearTimeout(this.timeout);
			if(!this.isMuted()){
				$("#audio_controls .mute").hide();
				$("#audio_controls .volume").show();
				this.timeout = setTimeout("audio.hideInfo()", OSD_TIMING);
			}else{
				$("#audio_controls .mute").show();
			}
			this.timeout = setTimeout("audio.hideInfo()", OSD_TIMING);
			break;
		case 2: //volume up
		case 3: //volume down
			clearTimeout(this.timeout);
			$("#audio_controls .volume").html(audio.getVolume()).show();
			this.timeout = setTimeout("audio.hideInfo()", OSD_TIMING);
			break;
	}
}

audio.hideInfo = function(){
	clearTimeout(this.timeout);
	$("#audio_controls .volume").hide();
	$("#audio_controls .mute").hide();
}