var player = {
	plugin : null,
	state : -1,
	skipState : -1,
	stopCallback : null,    /* Callback function to be set by client */
	originalSource : null,
	is_buffering: false,
	
	STOPPED : 0,
	PLAYING : 1,
	PAUSED : 2,
	BUFFERING: 3,
	timeout : null,
	timer_net: null
}

player.init = function(){
	var success = true;
	this.state = this.STOPPED;
	this.plugin = document.getElementById("pluginPlayer");
	if (!this.plugin){
		success = false;
	}else{
		var mwPlugin = document.getElementById("pluginTVMW");
		if (!mwPlugin){
			success = false;
		}else{
			/* Save current TV Source */
			this.originalSource = mwPlugin.GetSource();
			
			/* Set TV source to media player plugin */
			mwPlugin.SetMediaSource();
		}
	}
	this.setFullscreen();
	this.plugin.OnBufferingStart = 'player.onBufferingStart';
	this.plugin.OnBufferingProgress = 'player.onBufferingProgress';
	this.plugin.OnBufferingComplete = 'player.onBufferingComplete';           
	this.plugin.OnRenderingComplete = 'player.onRenderingComplete';       
	this.plugin.OnConnectionFailed = 'player.onConnectionFailed';
	this.plugin.OnStreamInfoReady = 'player.onStreamInfoReady';
	this.plugin.OnCurrentPlayTime = 'player.setCurTime';
	
	return success;
}
player.onStreamInfoReady = function(){
	this.state = this.PLAYING;
	$(".curT").html("0:00");
	var totaltime = this.plugin.GetDuration();
	alert("player.onStreamInfoReady - total time:"+totaltime);
	if(totaltime != -1){
		$(".totT").html(getFormattedTime(totaltime));
	}
}

player.setCurTime = function(time){
	//alert("player.setCurTime:"+time);
	time = parseInt(time, 10);
	if(time>0){
		$(".curT").html(getFormattedTime(time));
	}
}

player.onBufferingStart = function(){
	this.state = this.BUFFERING;
//	player.is_buffering = true;
	alert("buffering started: "+this.state);
	loader.start("center");
}
player.onBufferingProgress = function(){
	alert("buffering progress: "+this.state);
	this.state = this.BUFFERING;
}
player.onBufferingComplete = function(){
	loader.stop();
//	player.is_buffering = false;
	alert("buffering completed: "+this.state);
	this.viewDetails();
	
	if(this.state == this.PAUSED){
		this.resumeVideo();
	}else if(this.state == this.STOPPED){
		alert("stopped from buffering complete");
		this.stopVideo();
	}else{
		this.state = this.PLAYING;
	}
}

player.isBuffering = function(){
	return (this.state == this.BUFFERING);
}

player.onRenderingComplete = function(){
	this.nextVideo();
}
player.onConnectionFailed = function(){
	getNetworkAlert();
}

player.startNetworkChecker = function(){
	clearInterval(this.timer_net);
//	alert("network checked: play");
	this.timer_net = setInterval("player.checkNetwork()", 2000);
	return true;
}

player.checkNetwork = function(){
//	alert("network checked: check");
	if(!network.isConnected()){
		this.stopVideo();
		Main.backFromTrailer();
		getNetworkAlert();
	}
	return true;
}

player.stopNetworkChecker = function(){
//	alert("network checked: stop");
	clearInterval(this.timer_net);
	this.timer_net = null;
	return true;
}

player.deinit = function(){
	//var mwPlugin = document.getElementById("pluginTVMW");
	//if (mwPlugin && (this.originalSource != null) )
	/*{
		mwPlugin.SetSource(this.originalSource);
		alert("Restore source to " + this.originalSource);
	}*/
	this.hideOSD();
	this.stopNetworkChecker();
	loader.stop();
	alert('Player deinit !!! ');
	if (this.plugin) {
		this.plugin.Stop();
	}
}
player.setFullscreen = function(){
	this.plugin.SetDisplayArea(0, 0, 960, 540);
}

player.setVideoURL = function(url){
	this.url = url;
	alert("URL = " + this.url);
}

player.playVideo = function(){
	this.setVideoURL(playlist_trailers[choosed_trailer]);
	if (this.url == null){
		alert("No videos to play");
	}else{
		alert("player playVideo");
		this.setFullscreen();
		this.startNetworkChecker();
		alert("PLAY TO PLAYER");
		if(pages[viewing_page_id]=="player"){
			this.plugin.Play( this.url );
			alert(this.url);
			alert("video playing: "+this.isBuffering());
			//alert("played video : "+audio.plugin.GetUserMute());
			//alert("audio is muted :"+audio.isMuted());
			if(audio.isMuted()){
				audio.plugin.SetUserMute(PLR_TRUE);
			}else{
				audio.plugin.SetUserMute(PLR_FALSE);
			}
			audio.showInfo(1);
		
		}
	}
}

player.pauseVideo = function(){
	if(this.state == this.PLAYING){
		alert("player pauseVideo");
		var noerr = this.plugin.Pause();
		if(noerr){
			this.state = this.PAUSED;
			this.stopNetworkChecker();
			this.showOSD(1);
			this.viewDetails();
			alert("pause video");
		}
	}
}

player.stopVideo = function(){
	alert("||||||||||| STOP |||||||||");
	if (this.state != this.STOPPED){
		var noerr = this.plugin.Stop();
		if(noerr){
			this.state = this.STOPPED;
			this.stopNetworkChecker();
			alert("||||||||||| STOP OK |||||||||");
			//$("#audio_controls").hide();
			audio.hideInfo();
			
			if (this.stopCallback){
				this.stopCallback();
			}
			this.hideOSD();
			$("#onscreen_details, #cinetrailer_logo").hide();
		}else{
			this.stopVideo();
		}
	}
}

player.resumeVideo = function(){
	if(this.state == this.PAUSED){
		alert("player resumeVideo");
		var noerr = this.plugin.Resume();
		if(noerr){
			this.state = this.PLAYING;
			this.startNetworkChecker();
			this.showOSD(2);
			this.viewDetails();
		}
	}
}

player.nextVideo = function(){
	alert("next video");
	this.hideOSD();
	choosed_trailer++;
	this.stopCallback = null;
	if( choosed_trailer <= (playlist_trailers.length-1) ){
		this.stopVideo();
		this.playVideo();
	}else{
		this.stopVideo();
		Main.backFromTrailer();
		choosed_trailer = 0;
	}
}
player.previousVideo = function(){
	alert("previous video");
	this.hideOSD();
	choosed_trailer--;
	this.stopCallback = null;
	if( choosed_trailer >= 0 ){
		this.stopVideo();
		this.playVideo();
	}else{
		this.stopVideo();
		Main.backFromTrailer();
		choosed_trailer = 0;
	}
}

player.viewDetails = function(){
	$("#onscreen_details .title").html( $("#list_movies div.focused").data("title") );
	$("#onscreen_details .number_playing").html((choosed_trailer+1)+"/"+playlist_trailers.length);
	
	var poster = new Image();
	poster.src = $("#list_movies div.focused").data("poster");
	$("#onscreen_details .cover_big").html("").append(poster);
	
	if(selected_category==4){
		$("#onscreen_details .secondline").html( getTextFromDictionary("HOME_VIDEO") );
	}else{
		$("#onscreen_details .secondline").html( getTextFromDictionary("PREMIERE_DATE") + " " + $("#list_movies div.focused").data("premiere") );
	}
	
	this.showDetails();
}

player.showDetails = function(){
	if(this.state != this.STOPPED){
		alert("show details");
		$("#onscreen_details, #cinetrailer_logo").fadeIn(TIMING_FADE_ANIMATIONS);
		timer = setTimeout("player.hideDetails()", (TIMING_TRAILER_DETAILS+TIMING_FADE_ANIMATIONS));
	}
}

player.hideDetails = function(){
	clearTimeout(timer);
	if(this.state != this.PAUSED){
		$("#onscreen_details").fadeOut(TIMING_FADE_ANIMATIONS);
	}
}


player.showOSD = function(type){
	$("#os_pause, #os_play").hide();
	switch (type) {
		case 1: //pause
			$("#os_pause").show();
			break;
		case 2: //play
			clearTimeout(this.timeout);
			$("#os_play").show();
			this.timeout = setTimeout("player.hideOSD()", OSD_TIMING);
			break;
	}
}

player.hideOSD = function(){
	clearTimeout(this.timeout);
	$("#os_pause, #os_play").hide();
}